Wt: Wt::WCalendar Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Member Functions | List of all members
Wt::WCalendar Class Reference

A calendar. More...

`#include <Wt/WCalendar.h>`

Inheritance diagram for Wt::WCalendar:
[legend]

## Public Types
typedef CalendarHeaderFormat | HeaderFormat
| Typedef for enum Wt::CalendarHeaderFormat.
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.

## Public Member Functions
| WCalendar ()
| Creates a new calendar.
void | setSelectionMode (SelectionMode mode)
| Sets the selection mode.
void | browseToPreviousYear ()
| Browses to the same month in the previous year.
void | browseToPreviousMonth ()
| Browses to the previous month.
void | browseToNextYear ()
| Browses to the same month in the next year.
void | browseToNextMonth ()
| Browses to the next month.
void | browseTo (const WDate &date)
| Browses to a date.
int | currentMonth () const
| Returns the current month displayed.
int | currentYear () const
| Returns the current year displayed.
void | clearSelection ()
| Clears the current selection.
void | select (const WDate &date)
| Selects a date.
void | select (const std::set< WDate > &dates)
| Selects multiple dates.
void | setHorizontalHeaderFormat (CalendarHeaderFormat format)
| Sets the horizontal header format.
CalendarHeaderFormat | horizontalHeaderFormat ()
| Returns the horizontal header format.
void | setFirstDayOfWeek (int dayOfWeek)
| Sets the first day of the week.
const std::set< WDate > & | selection () const
| Returns the current selection.
Signal & | selectionChanged ()
| Signal emitted when the user changes the selection.
Signal< WDate > & | activated ()
| Signal emitted when the user double-clicks a date.
Signal< WDate > & | clicked ()
| Signal emitted when the user clicks a date.
Signal< int, int > & | currentPageChanged ()
| Signal emitted when the current month is changed.
void | setSingleClickSelect (bool single)
| Configures the calendar to use single click for activation.
void | setBottom (const WDate &bottom)
| Sets the bottom of the valid date range.
const WDate & | bottom () const
| Returns the bottom date of the valid range.
void | setTop (const WDate &top)
| Sets the top of the valid date range.
const WDate & | top () const
| Returns the top date of the valid range.
virtual void | load () override
| Loads content just before the widget is used.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > renderFlags) override
| Renders the widget.
virtual WWidget * | renderCell (WWidget *widget, const WDate &date)
| Creates or updates a widget that renders a cell.
bool | isSelected (const WDate &date) const
| Returns whether a date is selected.
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
Protected Member Functions inherited from Wt::WCompositeWidget
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A calendar.

The calendar provides navigation by month and year, and indicates the current day.

You can listen for single click or double click events on a calendar cell using the clicked() and activated() methods.

The calendar may be configured to allow selection of single or multiple days using setSelectionMode(), and you may listen for changes in the selection using the selectionChanged() signals. Selection can also be entirely disabled in which case you can implement your own selection handling by listening for cell click events.

Cell rendering may be customized by reimplementing renderCell().

Internationalization is provided by the internationalization features of the Wt::WDate class.

Usage example:

Wt::WDate today = Wt::WDate::currentDate();
Wt::WCalendar *calendar = addWidget(std::make_unique<Wt::WCalendar>());
calendar->browseTo(today.addMonths(1));
calendar->select(today.addMonths(1).addDays(3));
calendar->selected().connect(this, &MyWidget::daySelected);
Wt::WCalendar
A calendar.
Definition WCalendar.h:72
Wt::WCalendar::browseTo
void browseTo(const WDate &date)
Browses to a date.
Wt::WCalendar::select
void select(const WDate &date)
Selects a date.
Wt::WDate
A value class that represents a date on the Gregorian calendar.
Definition WDate.h:62
Wt::WDate::addMonths
WDate addMonths(int nmonths) const
Adds months.
Wt::WDate::currentDate
static WDate currentDate()
Reports the current client date.
Wt::WDate::addDays
WDate addDays(int ndays) const
Adds days.

Here is a snapshot, taken on 19/01/2010 (shown as today), and 14/01/2010 currently selected.

WCalendar with default look | WCalendar with polished look

## Constructor & Destructor Documentation

## ◆ WCalendar()

Wt::WCalendar::WCalendar | ( |  | ) |

Creates a new calendar.

Constructs a new calendar with English day/month names. The calendar shows the current day, and has an empty selection.

## Member Function Documentation

## ◆ activated()

Signal< WDate > & Wt::WCalendar::activated | ( |  | ) |

Signal emitted when the user double-clicks a date.

You may want to connect to this signal to treat a double click as the selection of a date.

## ◆ browseTo()

void Wt::WCalendar::browseTo | ( | const WDate & | date | ) |

Browses to a date.

Displays the month which contains the given date. This does not change the current selection.

This will emit the currentPageChanged() signal if another month is displayed.

## ◆ browseToNextMonth()

void Wt::WCalendar::browseToNextMonth | ( |  | ) |

Browses to the next month.

Displays the next month. This does not change the current selection.

This will emit the currentPageChanged() singal.

## ◆ browseToNextYear()

void Wt::WCalendar::browseToNextYear | ( |  | ) |

Browses to the same month in the next year.

Displays the same month in the next year. This does not change the current selection.

This will emit the currentPageChanged() singal.

## ◆ browseToPreviousMonth()

void Wt::WCalendar::browseToPreviousMonth | ( |  | ) |

Browses to the previous month.

Displays the previous month. This does not affect the selection.

This will emit the currentPageChanged() singal.

## ◆ browseToPreviousYear()

void Wt::WCalendar::browseToPreviousYear | ( |  | ) |

Browses to the same month in the previous year.

Displays the same month in the previous year. This does not affect the selection.

This will emit the currentPageChanged() singal.

## ◆ clearSelection()

void Wt::WCalendar::clearSelection | ( |  | ) |

Clears the current selection.

Clears the current selection. Will result in a selection() that is empty().

## ◆ clicked()

Signal< WDate > & Wt::WCalendar::clicked | ( |  | ) |

Signal emitted when the user clicks a date.

You may want to connect to this signal if you want to provide a custom selection handling.

## ◆ currentMonth()

int Wt::WCalendar::currentMonth | ( |  | ) | const

Returns the current month displayed.

Returns the month (1-12) that is currently displayed.

## ◆ currentPageChanged()

Signal< int, int > & Wt::WCalendar::currentPageChanged | ( |  | ) |

Signal emitted when the current month is changed.

The method is emitted both when the change is done through the user interface or via the public API. The two parameters are respectively the new year and month.

## ◆ currentYear()

int Wt::WCalendar::currentYear | ( |  | ) | const

Returns the current year displayed.

Returns the year that is currently displayed.

## ◆ enableAjax()

virtual void Wt::WCalendar::enableAjax | ( |  | ) |
| overrideprotectedvirtual

Progresses to an Ajax-enabled widget.

This method is called when the progressive bootstrap method is used, and support for AJAX has been detected. The default behavior will upgrade the widget's event handling to use AJAX instead of full page reloads, and propagate the call to its children.

You may want to reimplement this method if you want to make changes to widget when AJAX is enabled. You should always call the base implementation.

See also
  WApplication::enableAjax()

Reimplemented from Wt::WCompositeWidget.

## ◆ horizontalHeaderFormat()

CalendarHeaderFormat Wt::WCalendar::horizontalHeaderFormat | ( |  | ) |

Returns the horizontal header format.

See also
  setHorizontalHeaderFormat()

## ◆ isSelected()

bool Wt::WCalendar::isSelected | ( | const WDate & | date | ) | const
| protected

Returns whether a date is selected.

This is a convenience method that can be used when reimplementing renderCell().

## ◆ load()

virtual void Wt::WCalendar::load | ( |  | ) |
| overridevirtual

Loads content just before the widget is used.

This function is called when a widget is inserted in the widget hierarchy. Widgets that get inserted in the widget hierarchy will be rendered. Visible widgets are rendered immediately, and invisible widgets in the back-ground (or not for a plain HTML session). This method is called when the widget is directly or indirectly inserted into the widget tree.

The default implementation simply propagates the load signal to its children. You may want to override this method to delay loading of resource-intensive contents.

During the life-time of a widget, this method may be called multiple times, so you should make sure that you do a deferred initialization only once.

Reimplemented from Wt::WCompositeWidget.

## ◆ render()

virtual void Wt::WCalendar::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WCompositeWidget.

## ◆ renderCell()

virtual WWidget * Wt::WCalendar::renderCell | ( | WWidget * | widget,
|  | const WDate & | date )
| protectedvirtual

Creates or updates a widget that renders a cell.

The default implementation creates a WText

You may want to reimplement this method if you wish to customize how a cell is rendered. When `widget` is `0`, a new widget should be created and returned. Otherwise, you may either modify the passed `widget`, or return a new widget. If you return a new widget, the prevoius widget will be deleted.

## ◆ select() [1/2]

void Wt::WCalendar::select | ( | const std::set< WDate > & | dates | ) |

Selects multiple dates.

Select multiple dates. In multiple selection mode, this results in a selection() that contains exactly the given dates. In single selection mode, at most one date is set.

## ◆ select() [2/2]

void Wt::WCalendar::select | ( | const WDate & | date | ) |

Selects a date.

Select one date. Both in single or multiple selection mode, this results in a selection() that contains exactly one date.

## ◆ selection()

const std::set< WDate > & Wt::WCalendar::selection | ( |  | ) | const

Returns the current selection.

Returns the set of dates currently selected. In single selection mode, this set contains 0 or 1 dates.

## ◆ selectionChanged()

Signal & Wt::WCalendar::selectionChanged | ( |  | ) |

Signal emitted when the user changes the selection.

Emitted after the user has changed the current selection.

## ◆ setBottom()

void Wt::WCalendar::setBottom | ( | const WDate & | bottom | ) |

Sets the bottom of the valid date range.

The default is a null date constructed using WDate().

## ◆ setFirstDayOfWeek()

void Wt::WCalendar::setFirstDayOfWeek | ( | int | dayOfWeek | ) |

Sets the first day of the week.

Possible values are 1 to 7. The default value is 1 ("Monday").

## ◆ setHorizontalHeaderFormat()

void Wt::WCalendar::setHorizontalHeaderFormat | ( | CalendarHeaderFormat | format | ) |

Sets the horizontal header format.

The default horizontal header format is CalendarHeaderFormat::ShortDayNames.

## ◆ setSelectionMode()

void Wt::WCalendar::setSelectionMode | ( | SelectionMode | mode | ) |

Sets the selection mode.

The default selection mode is SingleSelection.

## ◆ setSingleClickSelect()

void Wt::WCalendar::setSingleClickSelect | ( | bool | single | ) |

Configures the calendar to use single click for activation.

By default, double click will trigger activate(). Use this method if you want a single click to trigger activate() (and the now deprecated selected() method). This only applies to a single-selection calendar.

If selectionMode() is set to SingleSelection, this will cause the selection to change on a single click instead of a double click.

Instead of enabling single click, you can also listen to the clicked() signal to process a single click.

See also
  setSelectionMode()

## ◆ setTop()

void Wt::WCalendar::setTop | ( | const WDate & | top | ) |

Sets the top of the valid date range.

The default is a null date constructed using WDate().